/// <reference types="bunyan" />
import { PubSubEngine } from 'graphql-subscriptions/dist/pubsub';
import Logger from 'bunyan';
export interface NatsPubSubOptions {
    config: string | any;
    connectionListener?: (err: Error) => void;
    logger?: Logger;
}
export declare class PubSub implements PubSubEngine {
    logger: Logger;
    connection: any;
    nextId: number;
    listeners: Map<number, any>;
    refs: Map<any, Array<number>>;
    subscriptions: Map<any, any>;
    constructor(options: NatsPubSubOptions);
    publish(topic: any, payload: any): boolean;
    subscribe(topic: String, onMessage: Function): Promise<number>;
    unsubscribe(sid: number): void;
    private onMessage(topic, msg);
}
